module Boundary_Condition

  use Constants
  implicit none
  private

  type, public :: BoundaryCondition
    character(len=25)      :: name = '' ! boundary condition name

! Änderung 17.10.2007
    character              :: key = '' ! SEMTEX boundary group key
    character(len=25)      :: periodic_link = '' ! Associated bc name, only for periodic boundaries

  end type BoundaryCondition

  type(BoundaryCondition), public, save, allocatable :: ControlBoundaryCondition(:)

  public :: GetBndryConditionControlData

contains

!===============================================================================

subroutine GetBndryConditionControlData(unit)
  integer, intent(in) :: unit

! Änderung 17.10.2007
  integer	      :: i, N, ios
  character(len=25)   :: name, periodic_link
  character           :: key

  namelist/boundary_condition/ name, key, periodic_link

  ! count number of user boundary conditions
  N = 0
  rewind(unit)
  do
    name = ''
    read(unit,nml=boundary_condition,IOSTAT=ios)
    if (ios /= 0) exit
    if (LEN_TRIM(name) > 0) N = N + 1
  end do
  allocate( ControlBoundaryCondition(N) )
  rewind(unit)

  do i = 1, N
    name = ControlBoundaryCondition(i)%name
!   Änderung 17.10.2007
    key           = ControlBoundaryCondition(i)%key
    periodic_link = ControlBoundaryCondition(i)%periodic_link
    do
      name = ''
      read(unit,nml=boundary_condition)
      if (LEN_TRIM(name) > 0) exit
    end do
    ControlBoundaryCondition(i)%name = name
!   Änderung 17.10.2007
    ControlBoundaryCondition(i)%key           = key
    ControlBoundaryCondition(i)%periodic_link = periodic_link
  end do

end subroutine GetBndryConditionControlData

!===============================================================================

end module Boundary_Condition
